#include <config.h>
program main_gfix
!
!$Id: main_gfix.F90,v 1.3 2011/04/20 12:25:22 ishikawa Exp $
!
! Coulomb or Landau gaguge fixing program.
!
! Maximizing GF functional by Gauge transfomation using
! Cabibbo-Marinari su(2) (CM) subgroup maximization, and Mino's Over-
! Relaxation (OR) method.
!
  use lattice_class, only : nodeid, CHARLEN
  use fix_gauge_class
  implicit none
  character(len=CHARLEN), parameter :: &
 &  prog_ver="$Id: main_gfix.F90,v 1.3 2011/04/20 12:25:22 ishikawa Exp $"
  type(fix_gauge) :: gfix

  call new(gfix)

  if (nodeid==0) then
    write(*,'(80("="))')
    write(*,'(1X,A," for ",A)')TRIM(prog_ver),TRIM(_VERSION_)
    write(*,'(80("="))')
  endif

  call read(gfix)
  call print(gfix)
  call run(gfix)
  call print_statistics(gfix)
  call delete(gfix)

  stop
end program
