//
// fortran vars
//
extern "C"       int cu_mult_count[_MAXGPU];
extern "C" const int cu_nodeid;
extern "C" const int cu_ipsite[NDIM];
extern "C" const int cu_ipeo;
extern "C" const int cu_nodeidup[NDIM-1];
extern "C" const int cu_nodeiddn[NDIM-1];

#define _multiter_        (cu_mult_count[0])
#define _nodeid_          (cu_nodeid)
#define _ipsite_x_        (cu_ipsite[0])
#define _ipsite_y_        (cu_ipsite[1])
#define _ipsite_z_        (cu_ipsite[2])
#define _ipsite_t_        (cu_ipsite[3])
#define _ipsite_(mu_)     (cu_ipsite[mu_])
#define _ipeo_            (cu_ipeo)
#define _nodeidup_(mu_)   (cu_nodeidup[mu_])
#define _nodeiddn_(mu_)   (cu_nodeiddn[mu_])

#if   _FERMI_BOUNDARY_GPBC_THETA_TYPE == 1

// theta = 1/2
#  define   GPBC_FACTOR_COS   (0.87758256189037271611f)
#  define   GPBC_FACTOR_SIN   (0.47942553860420300027f)

#elif _FERMI_BOUNDARY_GPBC_THETA_TYPE == 2

// theta = 1
#  define   GPBC_FACTOR_COS   (0.54030230586813971740f)
#  define   GPBC_FACTOR_SIN   (0.84147098480789650665f)

#elif _FERMI_BOUNDARY_GPBC_THETA_TYPE == 3

// theta = 1/10
#  define   GPBC_FACTOR_COS   (0.99500416527802576609f)
#  define   GPBC_FACTOR_SIN   (0.09983341664682815230f)

#elif _FERMI_BOUNDARY_GPBC_THETA_TYPE == 4

// theta = Pi
#  define   GPBC_FACTOR_COS   (-1.0f)
#  define   GPBC_FACTOR_SIN   ( 0.0f)

#elif _FERMI_BOUNDARY_GPBC_THETA_TYPE == 5

// theta = 0
#  define   GPBC_FACTOR_COS   ( 1.0f)
#  define   GPBC_FACTOR_SIN   ( 0.0f)

#elif _FERMI_BOUNDARY_GPBC_THETA_TYPE == 6

// theta = Pi/5
#  define   GPBC_FACTOR_COS   (0.80901699437494742410f)
#  define   GPBC_FACTOR_SIN   (0.58778525229247312917f)

#endif
