/*
*  $Id: qmx_lib.h,v 1.5 2011/08/16 13:37:36 ishikawa Exp $
*  QMX: Header file for QCD communication API on top of the Open-MX API.
*/
#ifndef __QMX_LIB_H__
#define __QMX_LIB_H__

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>
#include <math.h>
#include <complex>
#include <omp.h>
#include "myriexpress.h"
#include "mx_extensions.h"

extern "C" int qmx_get_rank_size();
extern "C" int qmx_get_local_rank();
extern "C" int qmx_get_1d_next_rank();
extern "C" int qmx_get_1d_prev_rank();
extern "C" int qmx_get_2d_local_rank_x();
extern "C" int qmx_get_2d_local_rank_y();
extern "C" int qmx_get_2d_next_x_rank();
extern "C" int qmx_get_2d_next_y_rank();
extern "C" int qmx_get_2d_prev_x_rank();
extern "C" int qmx_get_2d_prev_y_rank();

extern "C" void qmx_clock(double *time);
extern "C" void qmx_init();
extern "C" void qmx_finalize();
extern "C" void qmx_barrier();

extern "C" void qmx_bcast_int(int size, int *sdat, int rank);
extern "C" void qmx_bcast_char(int size, char *sdat, int rank);
extern "C" void qmx_bcast_float(int size, float *sdat, int rank);
extern "C" void qmx_bcast_double(int size, double *sdat, int rank);
extern "C" void qmx_bcast_cmplx(int size, std::complex<float> *sdat, int rank);
extern "C" void qmx_bcast_dcmplx(int size, std::complex<double> *sdat, int rank);

extern "C" void qmx_sumcast_int(int size, int *sdat);
extern "C" void qmx_sumcast_char(int size, char *sdat);
extern "C" void qmx_sumcast_float(int size, float *sdat);
extern "C" void qmx_sumcast_double(int size, double *sdat);
extern "C" void qmx_sumcast_cmplx(int size, std::complex<float> *sdat);
extern "C" void qmx_sumcast_dcmplx(int size, std::complex<double> *sdat);

extern "C" void qmx_allgather_int(int size, int *sdat, int *rdat);
extern "C" void qmx_allgather_char(int size, char *sdat, char *rdat);
extern "C" void qmx_allgather_float(int size, float *sdat, float *rdat);
extern "C" void qmx_allgather_double(int size, double *sdat, double *rdat);
extern "C" void qmx_allgather_cmplx(int size, std::complex<float> *sdat, std::complex<float> *rdat);
extern "C" void qmx_allgather_dcmplx(int size, std::complex<double> *sdat, std::complex<double> *rdat);

extern "C" void qmx_sendrecv_int(int size, int *sdat, int to_rank, int *rdat, int from_rank);
extern "C" void qmx_sendrecv_char(int size, char *sdat, int to_rank, char *rdat, int from_rank);
extern "C" void qmx_sendrecv_float(int size, float *sdat, int to_rank, float *rdat, int from_rank);
extern "C" void qmx_sendrecv_double(int size, double *sdat, int to_rank, double *rdat, int from_rank);
extern "C" void qmx_sendrecv_cmplx(int size, std::complex<float> *sdat, int to_rank, std::complex<float> *rdat, int from_rank);
extern "C" void qmx_sendrecv_dcmplx(int size, std::complex<double> *sdat, int to_rank, std::complex<double> *rdat, int from_rank);

#endif
