#include <config.h>

program calc_reweight
!**********************************************************************
!* Calculate Reweighting factor
!*
!*  dS = |D/D' eta| ^2 - |eta|^2
!*
!*  eta : Gaussian noise
!*
!*  Weight  = exp(-dS)
!*
!* $Id: calc_reweight.F90,v 1.1 2009/02/02 08:52:08 ishikawa Exp $
!**********************************************************************
  use comlib
  use lattice_class
  use reweighting_class
  implicit none
  type(reweighting_obj) :: rewgt

!*****************************************
!* initialization
!*****************************************
  call new(rewgt)

!*****************************************
!* read parameters
!*****************************************
  call read(rewgt)

!*****************************************
!* print parameters
!*****************************************
  call print(rewgt)

  if (nodeid==0) write(*,'(80("="))')

!*****************************************
!* run reweighting
!*****************************************
  call run(rewgt)

  if (nodeid==0) write(*,'(80("="))')

!*****************************************
!* save parameters
!*****************************************
  call save(rewgt)

  if (nodeid==0) write(*,'(80("="))')

!*****************************************
!* print statistics
!*****************************************
  call print_statistics(rewgt)

  call delete(rewgt)

  stop
end program
